/*  Copyright (c) 2005, Applied Security, Inc.
    Jared DeMott, jdemott@appliedsec.com, www.appliedsec.com

    This file is part of ikefuzz.

    Ikefuzz is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    CmdLine is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ikefuzz; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include "x4/misc/UDPSENDTO.h"

/*for sending UDP data to some host via size&charbuf*/
int UDPSENDTO(unsigned int len, char * data)
{
   int sockid, retcode;
   struct sockaddr_in my_addr, server_addr;
   
   ///printf("Client: creating socket\n");
      if ( (sockid = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
      { printf("Client: socket failed: %d\n",errno); return(-1); }

   ///printf("Client: binding my local socket\n");
   bzero((char *) &my_addr, sizeof(my_addr));
   my_addr.sin_family = AF_INET;
   my_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   my_addr.sin_port = htons(MY_PORT_ID);
   if ( (bind(sockid, (struct sockaddr *) &my_addr, 
              sizeof(my_addr)) < 0) )
      { printf("Client: bind fail: %d\n",errno); return(-1); }   

   ///printf("Client: creating addr structure for server\n");
   bzero((char *) &server_addr, sizeof(server_addr));
   server_addr.sin_family = AF_INET;
   server_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
   server_addr.sin_port = htons(SERVER_PORT_ID);

   ///printf("Client: initializing message and sending\n");
   retcode = sendto(sockid,data,len,0,(struct sockaddr *) &server_addr, sizeof(server_addr));
   if (retcode <= -1)
     {printf("client: sendto failed: %d\n",errno); return(-1); }   

   /* close socket */
   close(sockid);
   
   return(0);
 }

