/*
 *    Copyright (c) 2003, Cipherica Labs. All rights reserved.
 *    See enclosed license.txt for redistribution information.
 *
 *    $Id: buffer.c,v 1.1 2003/04/04 19:56:53 alex Exp $
 */

#include "x4/misc/buffer.h"

void x4_buf_free(x4s_buf * b)
{
  x4_assert(b);

//jdd  if (b->data && b->end)
//jdd   x4_free(b->data);
  if (b->data && b->end)
  {
	//printf("b->data=%x. b->end=%x, b->len=%d\n", b->data, b->end, b->len);
    if(b->data == 0)
    {
	printf("tried to free null ptr, return before we crash!\n");
	return;
    }
    else
    	x4_free(b->data);
  }

  b->data = b->end = 0;
  b->len = 0;
}

void * x4_buf_resize(x4s_buf * b, size_t len)
{
  x4_assert(b);

  if (b->data && !b->end)
  {
    x4_assert(0);    /* resizing attached buf ?! */
    x4_buf_free(b); /* detach */
  }

  if (b->data + len < b->end)
  {
    b->len = len;
    /* $todo - shrink buffer if it wastes too much space */
  }
  else
  {
    uint8 * data;
    size_t  blen, nlen;

    nlen = (len < 128) ? 128 : len;

    data = x4_realloc(b->data, nlen);
    x4_assert(data);
    
    blen = b->len;

    x4_memset(data+blen, 0, nlen-blen);
    b->data = data;
    b->len  = len;
    b->end  = data+nlen;
  }

  return b->data;
}
